#include <stdio.h>
#include <boost/spirit/home/karma/numeric/detail/numeric_utils.hpp>

void main()
{
	using namespace boost::spirit;
	auto absSignedChar = traits::absolute_value<signed char>::call((signed char)-1);
	std::cout << "abs signed char(" << -1 << ") = " << (int)absSignedChar << std::endl;
	auto absChar = traits::absolute_value<char>::call((char)-1);
	std::cout << "abs char(" << -1 << ") = " << (int)absChar << std::endl;
	auto absShort = traits::absolute_value<short>::call((short)-1);
	std::cout << "abs short(" << -1 << ") = " << absShort << std::endl;
	auto absInt = traits::absolute_value<int>::call((int)-1);
	std::cout << "abs int(" << -1 << ") = " << absInt << std::endl;
	auto absLong = traits::absolute_value<long>::call((long)-1);
	std::cout << "abs long(" << -1 << ") = " << absLong << std::endl;
	auto absLongLong = traits::absolute_value<boost::long_long_type>::call((boost::long_long_type)-1);
	std::cout << "abs long long(" << -1 << ") = " << absLongLong << std::endl;
}